OpenShot Audio Library | OpenShotAudio: juce::GenericScopedUnlock< LockType > Class Template Reference

OpenShot Audio Library | OpenShotAudio 0.4.0

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::GenericScopedUnlock< LockType > Class Template Reference

`#include <juce_ScopedLock.h>`

## Public Member Functions
| GenericScopedUnlock (const LockType &lock) noexcept
| ~GenericScopedUnlock () noexcept

## Detailed Description

template<class LockType>
class juce::GenericScopedUnlock< LockType >

Automatically unlocks and re-locks a mutex object.

This is the reverse of a GenericScopedLock object - instead of locking the mutex for the lifetime of this object, it unlocks it.

Make sure you don't try to unlock mutexes that aren't actually locked!

e.g.

CriticalSection myCriticalSection;
for (;;)
{
const GenericScopedLock<CriticalSection> myScopedLock (myCriticalSection);
// myCriticalSection is now locked
... do some stuff with it locked ..
while (xyz)
{
... do some stuff with it locked ..
const GenericScopedUnlock<CriticalSection> unlocker (myCriticalSection);
// myCriticalSection is now unlocked for the remainder of this block,
// and re-locked at the end.
...do some stuff with it unlocked ...
}
// myCriticalSection gets unlocked here.
}
juce::CriticalSection
Definition juce_CriticalSection.h:43
juce::GenericScopedLock
Definition juce_ScopedLock.h:55
juce::GenericScopedUnlock
Definition juce_ScopedLock.h:126

See also
  GenericScopedLock, CriticalSection, ScopedLock, ScopedUnlock

Definition at line 125 of file juce_ScopedLock.h.

## Constructor & Destructor Documentation

## ◆ GenericScopedUnlock()

template<class LockType >

juce::GenericScopedUnlock< LockType >::GenericScopedUnlock | ( | const LockType & | lock | ) |
| inlineexplicitnoexcept

Creates a GenericScopedUnlock.

As soon as it is created, this will unlock the CriticalSection, and when the ScopedLock object is deleted, the CriticalSection will be re-locked.

Make sure this object is created and deleted by the same thread, otherwise there are no guarantees what will happen! Best just to use it as a local stack object, rather than creating one with the new() operator.

Definition at line 139 of file juce_ScopedLock.h.

## ◆ ~GenericScopedUnlock()

template<class LockType >

juce::GenericScopedUnlock< LockType >::~GenericScopedUnlock | ( |  | ) |
| inlinenoexcept

Destructor.

The CriticalSection will be unlocked when the destructor is called.

Make sure this object is created and deleted by the same thread, otherwise there are no guarantees what will happen!

Definition at line 148 of file juce_ScopedLock.h.

The documentation for this class was generated from the following file:

- juce_ScopedLock.h